/********************* (C) COPYRIGHT 2017 e-Design Co.,Ltd. ********************
File Name :      MMA8652FC.c
Version :        TS100 APP 2.18
Description:
Author :         Ning
Data:            2017/11/06

2015/07/07   ͳһ;
2017/11/20   ټж;
2017/11/21   Ż
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "APP_Version.h"
#include "Bios.h"
#include "Oled.h"
#include "MMA8652FC.h"
#include "I2C.h"
#include "CTRL.h"
#include "UI.h"

static int Read_ZYXDr(void);

u16 gactive = 0,gShift = 0;
u8 Accelerometer_pos = 1;//ټͺű־

typedef struct {
    u8  hi;
    u8  lo;
} DRByte;
typedef struct {
    DRByte  Byte;

} DR_Value;

DR_Value gX_value,gY_value,gZ_value;

/*******************************************************************************
: Get_MmaActive
:ȡٶȴ״̬
:NULL
ز:ٶȴ״̬
*******************************************************************************/
u16 Get_MmaActive(void)
{
    return gactive;
}
/*******************************************************************************
: Get_MmaActive
:XXXXXXXXXXXXXXXXXXXXXX
:XXXXXXXXXXXXXXddddddXXXXXXXX
ز:XXXXXXXXXXXXXXXXXXXXXX
*******************************************************************************/
u16 Get_MmaShift(void)
{
    return gShift;
}
/*******************************************************************************
: Get_MmaActive
:XXXXXXXXXXXXXXXXXXXXXX
:XXXXXXXXXXXXXXXXXXXXXX
ز:XXXXXXXXXXXXXXXXXXXXXX
*******************************************************************************/
void Set_MmaShift(u16 shift)
{
    gShift = shift;
}

/*******************************************************************************
: IIC_RegWrite
:RegַдData
:Reg еĵַData
ز: ɹ
*******************************************************************************/
void IIC_RegWrite(u8 reg,u8 data)
{
    u8 tx_data[20];
    
    tx_data[0]=reg;
    tx_data[1]=data;
    if(Accelerometer_pos)
    {
        I2C_PageWrite(tx_data,2,LIS_DEVICE_ADDR);
    }
    else
    {
        I2C_PageWrite(tx_data,2,DEVICE_ADDR);
    }
}
/*******************************************************************************
: IIC_RegRead
:Reg
:Reg еĵַgMmatxdata
ز: ɹ
*******************************************************************************/
int IIC_RegRead(u8 reg)
{
    u8 tx_data[20];
    tx_data[0] = reg;
    if(Accelerometer_pos)
    {
        I2C_PageRead(tx_data, 1, LIS_DEVICE_ADDR, reg);
    }
    else
    {
        I2C_PageRead(tx_data, 1, DEVICE_ADDR, reg);
    }
    return tx_data[0];
}
/*******************************************************************************
: StartUp_Accelerated
:Reg
:NULL
ز:NULL
*******************************************************************************/
void StartUp_Accelerated(void)
{
    if(Accelerometer_pos)
    {
        IIC_RegWrite(ST_CTRL_REG1,0x57);
        IIC_RegWrite(ST_CTRL_REG2,0x00);
        IIC_RegWrite(ST_CTRL_REG3,0x00);
        IIC_RegWrite(ST_CTRL_REG4,0x00);
        IIC_RegWrite(ST_CTRL_REG5,0x00);
    }
    else
    {
        IIC_RegWrite(CTRL_REG1, 0);
        //---- òΧ4g----------------------//
        IIC_RegWrite(XYZ_DATA_CFG_REG,FULL_SCALE_8G );//(IIC_RegRead(XYZ_DATA_CFG_REG) & ~FS_MASK)
        //--- ʱ100HZ------------------------------------//
        IIC_RegWrite(CTRL_REG1,  DataRateValue); //IIC_RegRead(CTRL_REG1)|
        //----òģʽ------------------------------------------------------//
        IIC_RegWrite(CTRL_REG2, 0);//(IIC_RegRead(CTRL_REG2) & ~MODS_MASK)
        //---------ģʽ------------------------------------//
        IIC_RegWrite(CTRL_REG1,ACTIVE_MASK );
    }
}
/*******************************************************************************
: Is_ST_LIS2DH12
:ټǷLIS2DH12
:NULL
ز:x,y,zķ
*******************************************************************************/
void Is_ST_LIS2DH12(void)
{
    if(IIC_RegRead(ST_WHO_AM_I) == 51)//ټж
    {
        Accelerometer_pos = 1;
    }
    else
    {
        Accelerometer_pos = 0;
    }
}
/*******************************************************************************
: Read_ZYXDr
:ȡXYZ
:NULL
ز:x,y,zķ
*******************************************************************************/
int Read_ZYXDr(void)
{
    u8 reg_flag;
    u8 ptr,i;
    u8 value[7];

    memset((u8*)&gX_value,0,6);
    //Poll the ZYXDR status bit and wait for it to set
    if(Accelerometer_pos)
    {
        reg_flag = IIC_RegRead(ST_STATUS_REG);
        if((reg_flag & ZYXDR_BIT) !=0) 
        {
            //Read 12/10-bit XYZ results using a 6 byte IIC access
            ptr=ST_OUT_X_L;
            for(i=0; i<6; i++) 
            {
                value[i] = IIC_RegRead(ptr++);
            }
            //Copy and save each result as a 16-bit left-justified value
            gX_value.Byte.lo = value[0];
            gX_value.Byte.hi = value[1];
            gY_value.Byte.lo = value[2];
            gY_value.Byte.hi = value[3];
            gZ_value.Byte.lo = value[4];
            gZ_value.Byte.hi = value[5];         
            return 1;         
        } 
        return 0;
    }
    else
    { 
        reg_flag = IIC_RegRead(STATUS_REG);
        if((reg_flag & ZYXDR_BIT) !=0) 
        {
            //Read 12/10-bit XYZ results using a 6 byte IIC access
            ptr=X_MSB_REG;
            for(i=0; i<6; i++) 
            {
                value[i] = IIC_RegRead(ptr++);
            }
            //Copy and save each result as a 16-bit left-justified value
            gX_value.Byte.hi = value[0];
            gX_value.Byte.lo = value[1];
            gY_value.Byte.hi = value[2];
            gY_value.Byte.lo = value[3];
            gZ_value.Byte.hi = value[4];
            gZ_value.Byte.lo = value[5];
            return 1;
        } 
        return 0;
    }
}
/*******************************************************************************
: Cheak_XYData
:xyķ仯
:ǰһxyxyԱ
ز:Ƿƶ
*******************************************************************************/
u16 Cheak_XYData(u16 x0,u16 y0,u16 x1,u16 y1)
{
    u16 active = 0;
    gShift = 0;

    if((x1 > (x0 + 16)) || (x1 < (x0 - 16)))  active = 1;
    if((y1 > (y0 + 16)) || (y1 < (y0 - 16)))  active = 1;

    if((x1 > (x0 + 32)) || (x1 < (x0 - 32)))  gShift = 1;
    if((y1 > (y0 + 32)) || (y1 < (y0 - 32)))  gShift = 1;

    return active;
}
/*******************************************************************************
: Update_X
:
:x
ز:NULL
*******************************************************************************/
u16 Update_X(void)
{
    u16 value,x;

    value = ((gX_value.Byte.hi<<8) | (gX_value.Byte.lo & 0xf0 ))>>4;
    if(gX_value.Byte.hi>0x7f)    x = (~value+1) & 0xfff;
    else                        x = value & 0xfff;

    return x;
}
/*******************************************************************************
: Update_Y
:
:NULL
ز:y
*******************************************************************************/
u16 Update_Y(void)
{
    u16 value,y;

    value = ((gY_value.Byte.hi<<8) | (gY_value.Byte.lo & 0xf0 ))>>4;
    if(gY_value.Byte.hi>0x7f)    y = (~value+1) & 0xfff;
    else                          y = value & 0xfff;

    return y;
}
/*******************************************************************************
: Update_z
:
:NULL
ز:z
*******************************************************************************/
u16 Update_Z(void)
{
    u16 value,z;

    value = ((gZ_value.Byte.hi<<8) | (gZ_value.Byte.lo & 0xf0 ))>>4;
    if(gZ_value.Byte.hi>0x7f)     z = (~value+1) & 0xfff;
    else                          z = value & 0xfff;

    return z;
}
/*******************************************************************************
: Check_Accelerated
:ٶȴǷƶ
:NULL
ز:NULL
*******************************************************************************/
void Check_Accelerated(void)
{
    static u16 x0 = 0,y0 = 0;
    u16 x1,y1;

    if(Read_ZYXDr()) { /*ݣ*/
        x1 = Update_X();
        y1 = Update_Y();
    } else  x1 = x0;
    y1 = y0;
    gactive = Cheak_XYData(x0,y0,x1,y1);/*Ƿƶ*/

    x0 = x1;
    y0 = y1;
}
/******************************** END OF FILE *********************************/
